<?php
/**
 * FiloBlu srl
 *
 * @category   FiloBlu
 * @package    FiloBlu_ReCaptcha
 * @copyright  FiloBlu srl (http://www.filoblu.com)
 *
 */

namespace FiloBlu\ReCaptcha\Observer\Frontend;

use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Json\EncoderInterface;
use FiloBlu\ReCaptcha\Api\ValidateInterface;
use FiloBlu\ReCaptcha\Helper\Data;
use Magento\Framework\App\ActionFlag;
use Magento\Framework\App\Action\Action;

class AjaxLoginObserver implements ObserverInterface
{
    protected $validateInterface;
    protected $helperData;
    protected $actionFlag;
    protected $jsonEncoderInterface;

    public function __construct(
        ValidateInterface $validateInterface,
        Data $helperData,
        ActionFlag $actionFlag,
        EncoderInterface $jsonEncoderInterface
    ) {
        $this->validateInterface = $validateInterface;
        $this->helperData = $helperData;
        $this->actionFlag = $actionFlag;
        $this->jsonEncoderInterface = $jsonEncoderInterface;
    }

    public function execute(Observer $observer)
    {
        if (!$this->helperData->getEnabledFrontend()) {
            return;
        }

        $controller = $observer->getControllerAction();

        if (!$this->validateInterface->validate()) {
            $this->actionFlag->set('', Action::FLAG_NO_DISPATCH, true);

            $jsonPayload = $this->jsonEncoderInterface->encode([
                'errors' => true,
                'message' => $this->helperData->getErrorDescription(),
            ]);
            $controller->getResponse()->representJson($jsonPayload);
        }
    }
}
